#!/usr/bin/env node
import r from "chalk";
import m from "node:path";
import p from "node:fs";
import I from "json5";
import E from "lodash.upperfirst";
import y from "lodash.camelcase";
import x from "lodash.kebabcase";
import L from "lodash.lowerfirst";
import d from "lodash.template";
import S from "prompts";
import { OutputModeEnum as $, handler as C } from "@done-coding/cli-template";
import k from "yargs";
import { hideBin as T } from "yargs/helpers";
import D from "lodash.curry";
var c = /* @__PURE__ */ ((e) => (e.ADD = "add", e.REMOVE = "remove", e.LIST = "list", e))(c || {});
const _ = (e, o) => {
  if (!/^[a-zA-Z]+[a-zA-Z0-9-]*$/.test(e))
    return console.log(r.red("组件名只能包含字母、数字、中划线")), process.exit(1);
  const { nameExcludes: t } = o;
  return t.includes(e) ? (console.log(
    r.red(`组件名: ${e}是保留名称。
保留名称: ${t.join(",")}`)
  ), process.exit(1)) : !0;
}, f = {
  version: "0.2.0-alpha.0",
  name: "@done-coding/cli-component",
  description: "组件命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "component"
  }
}, { namespaceDir: j, moduleName: A } = f.cliConfig, w = () => m.resolve(j, A), M = () => ({
  execDir: process.cwd(),
  templateDir: w()
}), g = (e) => {
  const { series: o, name: t } = e, s = E(y(t)), i = L(s), a = x(s), l = o ? E(y(o)) : "", n = l ? `${l}${s}` : "", u = x(n);
  return {
    series: l,
    name: s,
    nameLowerFirst: i,
    nameKebab: a,
    fullName: n,
    fullNameKebab: u,
    cls: u
  };
}, F = (e) => ({
  $: "$",
  ...M(),
  ...g(e)
}), h = () => {
  const e = m.resolve(w(), "index.json");
  if (!p.existsSync(e))
    return console.log(r.red(`模块入口文件不存在: ${e}`)), process.exit(1);
  const t = JSON.parse(p.readFileSync(e, "utf-8")).config;
  if (!t)
    return console.log(r.red(`配置文件相对路径不存在: ${t}`)), process.exit(1);
  const s = m.resolve(
    m.dirname(e),
    t
  );
  if (!p.existsSync(s))
    return console.log(r.red(`配置文件不存在: ${s}`)), process.exit(1);
  const i = I.parse(p.readFileSync(s, "utf-8")), a = M();
  return i.componentDir = d(i.componentDir)(a), i;
}, v = (e) => {
  const { componentDir: o, nameExcludes: t } = e;
  return p.statSync(o).isDirectory() ? p.readdirSync(o).map((l) => {
    const n = m.join(o, l);
    return p.statSync(n).isDirectory() ? (console.log("filePath:", n, m.basename(n)), m.basename(n)) : "";
  }).filter((l) => !(!l || t.includes(l))) : (console.log(r.red("组件源码路径不是目录")), process.exit(1));
}, K = async () => {
  console.log(r.blue("展示列表"));
  const e = h(), o = v(e);
  console.table(
    o.map((t) => {
      const { name: s, fullName: i } = g({
        ...e,
        name: t
      });
      return {
        [r.green("名称")]: s,
        [r.green("带系列名称")]: i,
        [r.green("绝对路径")]: m.resolve(e.componentDir, t)
      };
    })
  );
}, N = async ({
  name: e,
  config: o,
  command: t
}) => {
  if (![c.ADD, c.REMOVE].includes(t))
    return console.log(r.red(`不支持组件${t}操作`)), process.exit(1);
  const s = F({
    ...o,
    name: e
  }), i = JSON.stringify(s);
  for (const { entry: a, index: l } of o.list) {
    if (a) {
      const n = a;
      n != null && n.input && (n.input = d(n.input)(s)), n != null && n.output && (n.output = d(n.output)(s));
      const u = {
        ...a,
        envData: i,
        mode: $.APPEND,
        rollback: t === c.REMOVE,
        dealMarkdown: !0
      };
      await C(u);
    }
    if (l) {
      const n = l;
      n != null && n.input && (n.input = d(n.input)(s)), n != null && n.output && (n.output = d(n.output)(s));
      const u = {
        ...l,
        envData: i,
        mode: $.OVERWRITE,
        rollback: t === c.REMOVE,
        dealMarkdown: !0
      };
      await C(u);
    }
  }
}, U = async ({ name: e }) => {
  console.log(r.blue("添加组件"));
  let o;
  e ? o = e : o = (await S({
    type: "text",
    name: "name",
    message: "请输入组件名"
  })).name;
  const t = h();
  _(o, t);
  const { series: s } = t, i = await v(t);
  for (let a of i)
    if (g({
      series: s,
      name: o
    }).nameKebab === a)
      return console.log(r.red(`组件${a}已存在, 不能再次创建${o}组件`)), process.exit(1);
  return N({
    name: o,
    config: t,
    command: c.ADD
  });
}, z = async ({ name: e }) => {
  console.log(r.blue("移除组件"));
  const o = h(), t = await v(o);
  if (t.length === 0)
    return console.log(r.red("组件列表为空")), process.exit(1);
  let s;
  e ? s = e : s = (await S({
    type: "select",
    name: "name",
    message: "请选择要移除的组件",
    choices: t.map((a) => ({ title: a, value: a }))
  })).name;
  const { series: i } = o;
  for (let a of t)
    if (g({
      series: i,
      name: s
    }).nameKebab === a) {
      await N({
        name: s,
        config: o,
        command: c.REMOVE
      }), p.rmdirSync(m.resolve(o.componentDir, a));
      return;
    }
  return console.log(r.red(`组件${s}不存在`)), process.exit(1);
}, b = async (e, o) => (console.log("com", o), e === c.ADD ? U(o) : e === c.REMOVE ? z(o) : e === c.LIST ? K() : (console.log(r.red("无效的命令")), process.exit(1))), R = async (e) => {
  console.log("component 子命令处理函数", e);
}, P = f.cliConfig.moduleName, H = (e, o) => {
  console.log(e ? r.red(e) : r.red(o.message)), process.exit(1);
}, J = f.description, Z = `Usage: $0 ${P} <command> [options]`, B = "Usage: $0 <command> [options]", O = (e) => e.command({
  command: `${c.ADD} <name>`,
  describe: "新增一个组件",
  builder: (o) => o.positional("name", {
    describe: "组件名称",
    type: "string"
  }),
  handler: D(b)(c.ADD)
}).command({
  command: `${c.REMOVE} [name]`,
  describe: "删除一个组件",
  builder: (o) => o.positional("name", {
    describe: "组件名称",
    type: "string"
  }),
  handler: D(b)(c.REMOVE)
}).command({
  command: c.LIST,
  describe: "展示组件列表",
  handler: D(b)(c.LIST)
}).demandCommand(1), V = (e, o = !1) => o ? O(e.strict().usage(Z)) : O(
  e.strict().usage(B).help("help").version(f.version).alias("v", "version").alias("h", "help")
).fail(H).argv, W = (e) => V(e, !0), me = {
  command: P,
  describe: J,
  builder: W,
  handler: R
}, pe = async () => {
  const e = k(T(process.argv)), o = await V(e);
  return R(o);
};
export {
  me as a,
  pe as c,
  R as h
};
